#include <ctime>
#include <stack>

#define PRINTROOT(MSG) if (ISROOT) std::cout << "::" << __PRETTY_FUNCTION__ \
                                        << "::" << __LINE__ \
                                        << "::" << MSG << std::endl;
#define DISTPRINTINFO(MSG) std::cout << MPI_RANK << "::" << __PRETTY_FUNCTION__ \
                                << "::" << __LINE__ \
                                << "::" << MSG << std::endl;

#define PRINTTICTOCTOP if (ISROOT) std::cout << "tictoc::" << tictoc_stack.top() \
                                         << std::endl;

#define ISROOT this->m_mpicomm.rank() == 0
#define MPI_SIZE this->m_mpicomm.size()
#define MPI_RANK this->m_mpicomm.rank()
#define MPI_ROW_RANK this->m_mpicomm.row_rank()
#define MPI_COL_RANK this->m_mpicomm.col_rank()
#define NUMROWPROCS this->m_mpicomm.pr()
#define NUMCOLPROCS this->m_mpicomm.pc()


static std::stack<clock_t> tictoc_stack;

inline void tic() {
    tictoc_stack.push(clock());
}

inline double toc() {
    double rc = (static_cast<double>
                 (clock() - tictoc_stack.top())) / CLOCKS_PER_SEC;
    tictoc_stack.pop();
    return rc;
}